/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package test;

import java.io.IOException;
import javax.servlet.Servlet;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

/*
 * Here is the output when running on GlassFish 3.1 b18
 *
 * INFO: FilterLifecycle was successfully deployed in 842 milliseconds.
 * INFO: Servlet.init 1284912647141
 * INFO: Filter.init 1284912647166
 * INFO: Filter.init 1284912651045
 * INFO: Servlet.service 1284912651773
 *
 * Spec section 6.2.1 says:
 *
After deployment of the Web application, and before a request causes the container
to access a Web resource, the container must locate the list of filters that must be
applied to the Web resource as described below. The container must ensure that it
has instantiated a filter of the appropriate class for each filter in the list, and called
its init(FilterConfig config) method.
 *
 * Furthermore, section 10.12 states
 *
 *
When a web application is deployed into a container, the following steps must be
performed, in this order, before the web application begins processing client
requests.
 *
Instantiate an instance of each event listener identified by a <listener> element
in the deployment descriptor.
■ For instantiated listener instances that implement ServletContextListener, call
the contextInitialized() method.
■ Instantiate an instance of each filter identified by a <filter> element in the
deployment descriptor and call each filter instance’s init() method.
■ Instantiate an instance of each servlet identified by a <servlet> element that
includes a <load-on-startup> element in the order defined by the load-onstartup
element values, and call each servlet instance’s init() method.

 * The above output is concrete proof that the Servlet's init method is being
 * called *before* the filter's, in violation of section 10.12.
 */
public class EchoServletLifecycleServlet implements Servlet {

    private ServletConfig config;

    @Override
    public void init(ServletConfig config) throws ServletException {
        System.out.println("Servlet.init " + System.currentTimeMillis());
        this.config = config;
    }

    @Override
    public ServletConfig getServletConfig() {
        return config;
    }

    @Override
    public void service(ServletRequest req, ServletResponse res) throws ServletException, IOException {
        System.out.println("Servlet.service " + System.currentTimeMillis());
    }

    @Override
    public String getServletInfo() {
        return this.getClass().getName();
    }


    @Override
    public void destroy() {

    }
  
}
